---
title: Create a RUM operation strong link
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > RUM Operations
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create a RUM operation strong link{% #create-a-rum-operation-strong-link %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                          |
| ----------------- | --------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/rum/operations/strong_links |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/rum/operations/strong_links |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/rum/operations/strong_links      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/rum/operations/strong_links      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/rum/operations/strong_links  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/rum/operations/strong_links |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/rum/operations/strong_links     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/rum/operations/strong_links |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/rum/operations/strong_links |

### Overview

Create a strong link between a RUM operation and a feature, confirming that the feature belongs to the operation. The operation can be identified by `operation_id` or `operation_name`; if `operation_name` does not match an existing operation, a stub operation is created.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                        | Type     | Description                                                                                                                                                       |
| ------------ | ---------------------------- | -------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]       | object   | The data object for creating a RUM operation strong link.                                                                                                         |
| data         | attributes [*required*] | object   | Attributes for creating a RUM operation strong link.                                                                                                              |
| attributes   | application_id               | uuid     | The RUM application ID used when creating a stub operation from `operation_name`.                                                                                 |
| attributes   | description                  | string   | A description of the strong link.                                                                                                                                 |
| attributes   | feature_id [*required*] | string   | The unique identifier of the feature to link.                                                                                                                     |
| attributes   | operation_id                 | string   | The unique identifier of the RUM operation to link. Either `operation_id` or `operation_name` is required.                                                        |
| attributes   | operation_name               | string   | The name of the RUM operation to link. Either `operation_id` or `operation_name` is required. If no operation with this name exists, a stub operation is created. |
| attributes   | status                       | enum     | The status of a RUM operation strong link. Allowed enum values: `DRAFT,CONFIRMED,REJECTED`                                                                        |
| attributes   | tags                         | [string] | A list of tags associated with the strong link.                                                                                                                   |
| data         | type [*required*]       | enum     | The JSON:API type for RUM operation strong link resources. Allowed enum values: `strong_links`                                                                    |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "application_id": "string",
      "description": "string",
      "feature_id": "feature-123",
      "operation_id": "abc12345-1234-5678-abcd-ef1234567890",
      "operation_name": "string",
      "status": "CONFIRMED",
      "tags": []
    },
    "type": "strong_links"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
The response for a single RUM operation strong link.

| Parent field | Field                          | Type      | Description                                                                                    |
| ------------ | ------------------------------ | --------- | ---------------------------------------------------------------------------------------------- |
|              | data [*required*]         | object    | The data object in a RUM operation strong link response.                                       |
| data         | attributes [*required*]   | object    | Attributes of a RUM operation strong link response.                                            |
| attributes   | created_at                     | date-time | The timestamp when the strong link was created.                                                |
| attributes   | description                    | string    | A description of the strong link.                                                              |
| attributes   | feature_id [*required*]   | string    | The unique identifier of the linked feature.                                                   |
| attributes   | operation_id [*required*] | string    | The unique identifier of the linked RUM operation.                                             |
| attributes   | status [*required*]       | enum      | The status of a RUM operation strong link. Allowed enum values: `DRAFT,CONFIRMED,REJECTED`     |
| attributes   | tags                           | [string]  | A list of tags associated with the strong link.                                                |
| attributes   | updated_at                     | date-time | The timestamp when the strong link was last updated.                                           |
| data         | id [*required*]           | string    | The unique identifier of the strong link, formatted as `<operation_id>:<feature_id>`.          |
| data         | type [*required*]         | enum      | The JSON:API type for RUM operation strong link resources. Allowed enum values: `strong_links` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2019-09-19T10:00:00.000Z",
      "description": "string",
      "feature_id": "feature-123",
      "operation_id": "abc12345-1234-5678-abcd-ef1234567890",
      "status": "CONFIRMED",
      "tags": [],
      "updated_at": "2019-09-19T10:00:00.000Z"
    },
    "id": "abc12345-1234-5678-abcd-ef1234567890:feature-123",
    "type": "strong_links"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found. The referenced `operation_id` does not exist.
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="409" %}
Conflict. A strong link between this operation and feature already exists.
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/rum/operations/strong_links" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "feature_id": "feature-123"
    },
    "type": "strong_links"
  }
}
EOF 
                
##### 

```python
"""
Create a RUM operation strong link returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.rum_operations_api import RUMOperationsApi
from datadog_api_client.v2.model.rum_operation_strong_link_create_request import RUMOperationStrongLinkCreateRequest
from datadog_api_client.v2.model.rum_operation_strong_link_create_request_attributes import (
    RUMOperationStrongLinkCreateRequestAttributes,
)
from datadog_api_client.v2.model.rum_operation_strong_link_create_request_data import (
    RUMOperationStrongLinkCreateRequestData,
)
from datadog_api_client.v2.model.rum_operation_strong_link_status import RUMOperationStrongLinkStatus
from datadog_api_client.v2.model.rum_operation_strong_link_type import RUMOperationStrongLinkType

body = RUMOperationStrongLinkCreateRequest(
    data=RUMOperationStrongLinkCreateRequestData(
        attributes=RUMOperationStrongLinkCreateRequestAttributes(
            description=None,
            feature_id="feature-123",
            operation_id="abc12345-1234-5678-abcd-ef1234567890",
            status=RUMOperationStrongLinkStatus.CONFIRMED,
            tags=[],
        ),
        type=RUMOperationStrongLinkType.STRONG_LINKS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_rum_operation_strong_link"] = True
with ApiClient(configuration) as api_client:
    api_instance = RUMOperationsApi(api_client)
    response = api_instance.create_rum_operation_strong_link(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Create a RUM operation strong link returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_rum_operation_strong_link".to_sym] = true
end
api_instance = DatadogAPIClient::V2::RUMOperationsAPI.new

body = DatadogAPIClient::V2::RUMOperationStrongLinkCreateRequest.new({
  data: DatadogAPIClient::V2::RUMOperationStrongLinkCreateRequestData.new({
    attributes: DatadogAPIClient::V2::RUMOperationStrongLinkCreateRequestAttributes.new({
      description: nil,
      feature_id: "feature-123",
      operation_id: "abc12345-1234-5678-abcd-ef1234567890",
      status: DatadogAPIClient::V2::RUMOperationStrongLinkStatus::CONFIRMED,
      tags: [],
    }),
    type: DatadogAPIClient::V2::RUMOperationStrongLinkType::STRONG_LINKS,
  }),
})
p api_instance.create_rum_operation_strong_link(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Create a RUM operation strong link returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.RUMOperationStrongLinkCreateRequest{
		Data: datadogV2.RUMOperationStrongLinkCreateRequestData{
			Attributes: datadogV2.RUMOperationStrongLinkCreateRequestAttributes{
				Description: *datadog.NewNullableString(nil),
				FeatureId:   "feature-123",
				OperationId: datadog.PtrString("abc12345-1234-5678-abcd-ef1234567890"),
				Status:      datadogV2.RUMOPERATIONSTRONGLINKSTATUS_CONFIRMED.Ptr(),
				Tags:        []string{},
			},
			Type: datadogV2.RUMOPERATIONSTRONGLINKTYPE_STRONG_LINKS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateRUMOperationStrongLink", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewRUMOperationsApi(apiClient)
	resp, r, err := api.CreateRUMOperationStrongLink(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `RUMOperationsApi.CreateRUMOperationStrongLink`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `RUMOperationsApi.CreateRUMOperationStrongLink`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Create a RUM operation strong link returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.RumOperationsApi;
import com.datadog.api.client.v2.model.RUMOperationStrongLinkCreateRequest;
import com.datadog.api.client.v2.model.RUMOperationStrongLinkCreateRequestAttributes;
import com.datadog.api.client.v2.model.RUMOperationStrongLinkCreateRequestData;
import com.datadog.api.client.v2.model.RUMOperationStrongLinkResponse;
import com.datadog.api.client.v2.model.RUMOperationStrongLinkStatus;
import com.datadog.api.client.v2.model.RUMOperationStrongLinkType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createRUMOperationStrongLink", true);
    RumOperationsApi apiInstance = new RumOperationsApi(defaultClient);

    RUMOperationStrongLinkCreateRequest body =
        new RUMOperationStrongLinkCreateRequest()
            .data(
                new RUMOperationStrongLinkCreateRequestData()
                    .attributes(
                        new RUMOperationStrongLinkCreateRequestAttributes()
                            .description(null)
                            .featureId("feature-123")
                            .operationId("abc12345-1234-5678-abcd-ef1234567890")
                            .status(RUMOperationStrongLinkStatus.CONFIRMED))
                    .type(RUMOperationStrongLinkType.STRONG_LINKS));

    try {
      RUMOperationStrongLinkResponse result = apiInstance.createRUMOperationStrongLink(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling RumOperationsApi#createRUMOperationStrongLink");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Create a RUM operation strong link returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_rum_operations::RUMOperationsAPI;
use datadog_api_client::datadogV2::model::RUMOperationStrongLinkCreateRequest;
use datadog_api_client::datadogV2::model::RUMOperationStrongLinkCreateRequestAttributes;
use datadog_api_client::datadogV2::model::RUMOperationStrongLinkCreateRequestData;
use datadog_api_client::datadogV2::model::RUMOperationStrongLinkStatus;
use datadog_api_client::datadogV2::model::RUMOperationStrongLinkType;

#[tokio::main]
async fn main() {
    let body =
        RUMOperationStrongLinkCreateRequest::new(RUMOperationStrongLinkCreateRequestData::new(
            RUMOperationStrongLinkCreateRequestAttributes::new("feature-123".to_string())
                .description(None)
                .operation_id("abc12345-1234-5678-abcd-ef1234567890".to_string())
                .status(RUMOperationStrongLinkStatus::CONFIRMED)
                .tags(vec![]),
            RUMOperationStrongLinkType::STRONG_LINKS,
        ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateRUMOperationStrongLink", true);
    let api = RUMOperationsAPI::with_config(configuration);
    let resp = api.create_rum_operation_strong_link(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Create a RUM operation strong link returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createRUMOperationStrongLink"] = true;
const apiInstance = new v2.RUMOperationsApi(configuration);

const params: v2.RUMOperationsApiCreateRUMOperationStrongLinkRequest = {
  body: {
    data: {
      attributes: {
        description: undefined,
        featureId: "feature-123",
        operationId: "abc12345-1234-5678-abcd-ef1234567890",
        status: "CONFIRMED",
        tags: [],
      },
      type: "strong_links",
    },
  },
};

apiInstance
  .createRUMOperationStrongLink(params)
  .then((data: v2.RUMOperationStrongLinkResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
